$(() => {
$('#gridContainer').dxDataGrid({
dataSource: employees,
keyExpr: 'ID',
showBorders: true,
columns: [{
dataField: 'Prefix',
caption: 'Title',
width: 70,
},
'FirstName',
'LastName', {
dataField: 'Position',
width: 170,
}, {
dataField: 'State',
width: 125,
}, {
dataField: 'BirthDate',
dataType: 'date',
},
],
masterDetail: {
enabled: true,
template(container, options) {
const currentEmployeeData = options.data;
$('<div>')
.addClass('master-detail-caption')
.text(`${currentEmployeeData.FirstName} ${currentEmployeeData.LastName}'s Tasks:`)
.appendTo(container);
$('<div>')
.dxDataGrid({
columnAutoWidth: true,
showBorders: true,
columns: ['Subject', {
dataField: 'StartDate',
dataType: 'date',
}, {
dataField: 'DueDate',
dataType: 'date',
}, 'Priority', {
caption: 'Completed',
dataType: 'boolean',
calculateCellValue(rowData) {
return rowData.Status === 'Completed';
},
}],
dataSource: new DevExpress.data.DataSource({
store: new DevExpress.data.ArrayStore({
key: 'ID',
data: tasks,
}),
filter: ['EmployeeID', '=', options.key],
}),
}).appendTo(container);
},
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/22.1.3/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="gridContainer"></div>
</div>
</body>
</html>
#gridContainer {
height: 440px;
}
.master-detail-caption {
padding: 0 0 5px 10px;
font-size: 14px;
font-weight: bold;
}
const employees = [{
ID: 1,
Prefix: 'Mr.',
FirstName: 'John',
LastName: 'Heart',
Position: 'CEO',
State: 'California',
BirthDate: '1964/03/16',
},
{
ID: 2,
Prefix: 'Mrs.',
FirstName: 'Olivia',
LastName: 'Peyton',
Position: 'Sales Assistant',
State: 'California',
BirthDate: '1981/06/03',
},
{
ID: 3,
Prefix: 'Mr.',
FirstName: 'Robert',
LastName: 'Reagan',
Position: 'CMO',
State: 'Arkansas',
BirthDate: '1974/09/07',
},
{
ID: 4,
Prefix: 'Ms.',
FirstName: 'Greta',
LastName: 'Sims',
Position: 'HR Manager',
State: 'Georgia',
BirthDate: '1977/11/22',
},
{
ID: 5,
Prefix: 'Mr.',
FirstName: 'Brett',
LastName: 'Wade',
Position: 'IT Manager',
State: 'Idaho',
BirthDate: '1968/12/01',
},
{
ID: 6,
Prefix: 'Mrs.',
FirstName: 'Sandra',
LastName: 'Johnson',
Position: 'Controller',
State: 'Utah',
BirthDate: '1974/11/15',
},
{
ID: 7,
Prefix: 'Mr.',
FirstName: 'Kevin',
LastName: 'Carter',
Position: 'Shipping Manager',
State: 'California',
BirthDate: '1978/01/09',
},
{
ID: 8,
Prefix: 'Ms.',
FirstName: 'Cynthia',
LastName: 'Stanwick',
Position: 'HR Assistant',
State: 'Arkansas',
BirthDate: '1985/06/05',
},
{
ID: 9,
Prefix: 'Dr.',
FirstName: 'Kent',
LastName: 'Samuelson',
Position: 'Ombudsman',
State: 'Missouri',
BirthDate: '1972/09/11',
}];
const tasks = [{
ID: 1,
Subject: 'Prepare 2013 Financial',
StartDate: '2013/01/15',
DueDate: '2013/01/31',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 8,
},
{
ID: 2,
Subject: 'Prepare 3013 Marketing Plan',
StartDate: '2013/01/01',
DueDate: '2013/01/31',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 5,
},
{
ID: 3,
Subject: 'Update Personnel Files',
StartDate: '2013/02/03',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 2,
},
{
ID: 4,
Subject: 'Review Health Insurance Options Under the Affordable Care Act',
StartDate: '2013/02/12',
DueDate: '2013/04/25',
Status: 'In Progress',
Priority: 'High',
Completion: 50,
EmployeeID: 2,
},
{
ID: 5,
Subject: 'Choose between PPO and HMO Health Plan',
StartDate: '2013/02/15',
DueDate: '2013/04/15',
Status: 'In Progress',
Priority: 'High',
Completion: 75,
EmployeeID: 1,
},
{
ID: 6,
Subject: 'Google AdWords Strategy',
StartDate: '2013/02/16',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 7,
Subject: 'New Brochures',
StartDate: '2013/02/17',
DueDate: '2013/02/24',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 1,
},
{
ID: 11,
Subject: 'Rollout of New Website and Marketing Brochures',
StartDate: '2013/02/20',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 5,
},
{
ID: 12,
Subject: 'Update Sales Strategy Documents',
StartDate: '2013/02/20',
DueDate: '2013/02/22',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 9,
},
{
ID: 15,
Subject: 'Review 2012 Sales Report and Approve 2013 Plans',
StartDate: '2013/02/23',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 5,
},
{
ID: 16,
Subject: 'Deliver R&D Plans for 2013',
StartDate: '2013/03/01',
DueDate: '2013/03/10',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 3,
},
{
ID: 20,
Subject: 'Approve Hiring of John Jeffers',
StartDate: '2013/03/02',
DueDate: '2013/03/12',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 4,
},
{
ID: 20,
Subject: 'Approve Hiring of John Jeffers',
StartDate: '2013/03/02',
DueDate: '2013/03/12',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 6,
},
{
ID: 21,
Subject: 'Non-Compete Agreements',
StartDate: '2013/03/12',
DueDate: '2013/03/14',
Status: 'Completed',
Priority: 'Low',
Completion: 100,
EmployeeID: 2,
},
{
ID: 22,
Subject: 'Update NDA Agreement',
StartDate: '2013/03/14',
DueDate: '2013/03/16',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 23,
Subject: 'Update Employee Files with New NDA',
StartDate: '2013/03/16',
DueDate: '2013/03/26',
Status: 'Need Assistance',
Priority: 'Normal',
Completion: 90,
EmployeeID: 4,
},
{
ID: 24,
Subject: 'Update Employee Files with New NDA',
StartDate: '2013/03/16',
DueDate: '2013/03/26',
Status: 'Need Assistance',
Priority: 'Normal',
Completion: 90,
EmployeeID: 6,
},
{
ID: 25,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 7,
},
{
ID: 26,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 8,
},
{
ID: 27,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Need Assistance',
Priority: 'Urgent',
Completion: 25,
EmployeeID: 9,
},
{
ID: 35,
Subject: 'Update Revenue Projections',
StartDate: '2013/03/24',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 8,
},
{
ID: 36,
Subject: 'Review Revenue Projections',
StartDate: '2013/03/25',
DueDate: '2013/04/06',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 9,
},
{
ID: 40,
Subject: 'Provide New Health Insurance Docs',
StartDate: '2013/03/28',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 4,
},
{
ID: 41,
Subject: 'Provide New Health Insurance Docs',
StartDate: '2013/03/28',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 6,
},
{
ID: 50,
Subject: 'Give Final Approval for Refunds',
StartDate: '2013/05/05',
DueDate: '2013/05/15',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 2,
},
{
ID: 52,
Subject: 'Review Product Recall Report by Engineering Team',
StartDate: '2013/05/17',
DueDate: '2013/05/20',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 55,
Subject: 'Review Overtime Report',
StartDate: '2013/06/10',
DueDate: '2013/06/14',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 7,
},
{
ID: 60,
Subject: 'Refund Request Template',
StartDate: '2013/06/17',
DueDate: '2014/04/01',
Status: 'Deferred',
Priority: 'Normal',
Completion: 0,
EmployeeID: 9,
},
{
ID: 71,
Subject: 'Upgrade Server Hardware',
StartDate: '2013/07/22',
DueDate: '2013/07/31',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 7,
},
{
ID: 72,
Subject: 'Upgrade Personal Computers',
StartDate: '2013/07/24',
DueDate: '2014/04/30',
Status: 'In Progress',
Priority: 'Normal',
Completion: 85,
EmployeeID: 7,
},
{
ID: 74,
Subject: 'Decide on Mobile Devices to Use in the Field',
StartDate: '2013/07/30',
DueDate: '2013/08/02',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 3,
},
{
ID: 78,
Subject: 'Try New Touch-Enabled WinForms Apps',
StartDate: '2013/08/11',
DueDate: '2013/08/15',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 3,
},
{
ID: 81,
Subject: 'Review Site Up-Time Report',
StartDate: '2013/08/24',
DueDate: '2013/08/30',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 5,
},
{
ID: 99,
Subject: 'Submit D&B Number to ISP for Credit Approval',
StartDate: '2013/11/04',
DueDate: '2013/11/07',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 8,
},
{
ID: 117,
Subject: 'Approval on Converting to New HDMI Specification',
StartDate: '2014/01/11',
DueDate: '2014/01/31',
Status: 'Deferred',
Priority: 'Normal',
Completion: 75,
EmployeeID: 3,
},
{
ID: 138,
Subject: 'Review HR Budget Company Wide',
StartDate: '2014/03/20',
DueDate: '2014/03/25',
Status: 'In Progress',
Priority: 'Normal',
Completion: 40,
EmployeeID: 6,
},
{
ID: 145,
Subject: 'Final Budget Review',
StartDate: '2014/03/26',
DueDate: '2014/03/27',
Status: 'In Progress',
Priority: 'High',
Completion: 25,
EmployeeID: 6,
}];

<template>
<DxDataGrid
id="grid-container"
:show-borders="true"
:data-source="dataSource"
key-expr="ID"
>
<DxColumn
:width="70"
data-field="Prefix"
caption="Title"
/>
<DxColumn data-field="FirstName"/>
<DxColumn data-field="LastName"/>
<DxColumn
:width="170"
data-field="Position"
/>
<DxColumn
:width="125"
data-field="State"
/>
<DxColumn
data-field="BirthDate"
data-type="date"
/>
<DxMasterDetail
:enabled="true"
template="masterDetailTemplate"
/>
<template #masterDetailTemplate="{ data: employee }">
<DetailTemplate
:template-data="employee"
/>
</template>
</DxDataGrid>
</template>
<script>
import {
DxDataGrid,
DxColumn,
DxMasterDetail,
} from 'devextreme-vue/data-grid';
import DetailTemplate from './DetailTemplate.vue';
import service from './data.js';
const employees = service.getEmployees();
export default {
components: {
DxDataGrid,
DxColumn,
DxMasterDetail,
DetailTemplate
},
data() {
return {
dataSource: employees
};
}
};
</script>
<style>
#grid-container {
height: 440px;
}
</style>
<template>
<div>
<div class="master-detail-caption">{{ detailInfo }}</div>
<DxDataGrid
:data-source="dataSource"
:show-borders="true"
:column-auto-width="true"
>
<DxColumn data-field="Subject"/>
<DxColumn
data-field="StartDate"
data-type="date"
/>
<DxColumn
data-field="DueDate"
data-type="date"
/>
<DxColumn data-field="Priority"/>
<DxColumn
:calculate-cell-value="completedValue"
data-type="boolean"
caption="Completed"
/>
</DxDataGrid>
</div>
</template>
<script>
import { DxDataGrid, DxColumn } from 'devextreme-vue/data-grid';
import ArrayStore from 'devextreme/data/array_store';
import DataSource from 'devextreme/data/data_source';
import service from './data.js';
const tasks = service.getTasks();
export default {
components: { DxDataGrid, DxColumn },
props: {
templateData: {
type: Object,
default: ()=>{}
}
},
data() {
let { FirstName, LastName } = this.templateData.data;
return {
dataSource: this.getTasks(this.templateData.key),
detailInfo: `${FirstName } ${ LastName }'s Tasks`
};
},
methods: {
completedValue(rowData) {
return rowData.Status === 'Completed';
},
getTasks(key) {
return new DataSource({
store: new ArrayStore({
data: tasks,
key: 'ID'
}),
filter: ['EmployeeID', '=', key]
});
}
}
};
</script>
<style>
.master-detail-caption {
padding: 0 0 5px 10px;
font-size: 14px;
font-weight: bold;
}</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app">
</div>
</div>
</body>
</html>
const employees = [{
'ID': 1,
'Prefix': 'Mr.',
'FirstName': 'John',
'LastName': 'Heart',
'Position': 'CEO',
'State': 'California',
'BirthDate': '1964/03/16'
},
{
'ID': 2,
'Prefix': 'Mrs.',
'FirstName': 'Olivia',
'LastName': 'Peyton',
'Position': 'Sales Assistant',
'State': 'California',
'BirthDate': '1981/06/03'
},
{
'ID': 3,
'Prefix': 'Mr.',
'FirstName': 'Robert',
'LastName': 'Reagan',
'Position': 'CMO',
'State': 'Arkansas',
'BirthDate': '1974/09/07'
},
{
'ID': 4,
'Prefix': 'Ms.',
'FirstName': 'Greta',
'LastName': 'Sims',
'Position': 'HR Manager',
'State': 'Georgia',
'BirthDate': '1977/11/22'
},
{
'ID': 5,
'Prefix': 'Mr.',
'FirstName': 'Brett',
'LastName': 'Wade',
'Position': 'IT Manager',
'State': 'Idaho',
'BirthDate': '1968/12/01'
},
{
'ID': 6,
'Prefix': 'Mrs.',
'FirstName': 'Sandra',
'LastName': 'Johnson',
'Position': 'Controller',
'State': 'Utah',
'BirthDate': '1974/11/15'
},
{
'ID': 7,
'Prefix': 'Mr.',
'FirstName': 'Kevin',
'LastName': 'Carter',
'Position': 'Shipping Manager',
'State': 'California',
'BirthDate': '1978/01/09'
},
{
'ID': 8,
'Prefix': 'Ms.',
'FirstName': 'Cynthia',
'LastName': 'Stanwick',
'Position': 'HR Assistant',
'State': 'Arkansas',
'BirthDate': '1985/06/05'
},
{
'ID': 9,
'Prefix': 'Dr.',
'FirstName': 'Kent',
'LastName': 'Samuelson',
'Position': 'Ombudsman',
'State': 'Missouri',
'BirthDate': '1972/09/11'
}];
const tasks = [{
'ID': 1,
'Subject': 'Prepare 2013 Financial',
'StartDate': '2013/01/15',
'DueDate': '2013/01/31',
'Status': 'Completed',
'Priority': 'High',
'Completion': 100,
'EmployeeID': 8
},
{
'ID': 2, 'Subject': 'Prepare 3013 Marketing Plan',
'StartDate': '2013/01/01',
'DueDate': '2013/01/31',
'Status': 'Completed',
'Priority': 'High',
'Completion': 100,
'EmployeeID': 5
},
{
'ID': 3,
'Subject': 'Update Personnel Files',
'StartDate': '2013/02/03',
'DueDate': '2013/02/28',
'Status': 'Completed',
'Priority': 'High',
'Completion': 100,
'EmployeeID': 2
},
{
'ID': 4,
'Subject': 'Review Health Insurance Options Under the Affordable Care Act',
'StartDate': '2013/02/12',
'DueDate': '2013/04/25',
'Status': 'In Progress',
'Priority': 'High',
'Completion': 50,
'EmployeeID': 2
},
{
'ID': 5,
'Subject': 'Choose between PPO and HMO Health Plan',
'StartDate': '2013/02/15',
'DueDate': '2013/04/15',
'Status': 'In Progress', 'Priority': 'High',
'Completion': 75,
'EmployeeID': 1
},
{
'ID': 6,
'Subject': 'Google AdWords Strategy',
'StartDate': '2013/02/16',
'DueDate': '2013/02/28',
'Status': 'Completed',
'Priority': 'High',
'Completion': 100,
'EmployeeID': 1
},
{
'ID': 7,
'Subject': 'New Brochures',
'StartDate': '2013/02/17',
'DueDate': '2013/02/24',
'Status': 'Completed',
'Priority': 'Normal',
'Completion': 100,
'EmployeeID': 1
},
{
'ID': 11,
'Subject': 'Rollout of New Website and Marketing Brochures',
'StartDate': '2013/02/20',
'DueDate': '2013/02/28',
'Status': 'Completed',
'Priority': 'High',
'Completion': 100,
'EmployeeID': 5
},
{
'ID': 12,
'Subject': 'Update Sales Strategy Documents',
'StartDate': '2013/02/20',
'DueDate': '2013/02/22',
'Status': 'Completed',
'Priority': 'Normal',
'Completion': 100,
'EmployeeID': 9
},
{
'ID': 15,
'Subject': 'Review 2012 Sales Report and Approve 2013 Plans',
'StartDate': '2013/02/23',
'DueDate': '2013/02/28',
'Status': 'Completed',
'Priority': 'Normal',
'Completion': 100,
'EmployeeID': 5
},
{
'ID': 16,
'Subject': 'Deliver R&D Plans for 2013',
'StartDate': '2013/03/01',
'DueDate': '2013/03/10',
'Status': 'Completed',
'Priority': 'High',
'Completion': 100,
'EmployeeID': 3
},
{
'ID': 20,
'Subject': 'Approve Hiring of John Jeffers',
'StartDate': '2013/03/02',
'DueDate': '2013/03/12',
'Status': 'Completed',
'Priority': 'Normal',
'Completion': 100,
'EmployeeID': 4
},
{
'ID': 20,
'Subject': 'Approve Hiring of John Jeffers',
'StartDate': '2013/03/02',
'DueDate': '2013/03/12',
'Status': 'Completed',
'Priority': 'Normal',
'Completion': 100,
'EmployeeID': 6
},
{
'ID': 21,
'Subject': 'Non-Compete Agreements',
'StartDate': '2013/03/12',
'DueDate': '2013/03/14',
'Status': 'Completed',
'Priority': 'Low',
'Completion': 100,
'EmployeeID': 2
},
{
'ID': 22,
'Subject': 'Update NDA Agreement',
'StartDate': '2013/03/14',
'DueDate': '2013/03/16',
'Status': 'Completed',
'Priority': 'High',
'Completion': 100,
'EmployeeID': 1
},
{
'ID': 23,
'Subject': 'Update Employee Files with New NDA',
'StartDate': '2013/03/16',
'DueDate': '2013/03/26',
'Status': 'Need Assistance',
'Priority': 'Normal',
'Completion': 90,
'EmployeeID': 4
},
{
'ID': 24,
'Subject': 'Update Employee Files with New NDA',
'StartDate': '2013/03/16',
'DueDate': '2013/03/26',
'Status': 'Need Assistance',
'Priority': 'Normal',
'Completion': 90,
'EmployeeID': 6
},
{
'ID': 25,
'Subject': 'Sign Updated NDA',
'StartDate': '2013/03/20',
'DueDate': '2013/03/25',
'Status': 'Completed',
'Priority': 'Urgent',
'Completion': 100,
'EmployeeID': 7
},
{
'ID': 26,
'Subject': 'Sign Updated NDA',
'StartDate': '2013/03/20',
'DueDate': '2013/03/25',
'Status': 'Completed',
'Priority': 'Urgent',
'Completion': 100,
'EmployeeID': 8
},
{
'ID': 27,
'Subject': 'Sign Updated NDA',
'StartDate': '2013/03/20',
'DueDate': '2013/03/25',
'Status': 'Need Assistance',
'Priority': 'Urgent',
'Completion': 25,
'EmployeeID': 9
},
{
'ID': 35,
'Subject': 'Update Revenue Projections',
'StartDate': '2013/03/24',
'DueDate': '2013/04/07',
'Status': 'Completed',
'Priority': 'Normal',
'Completion': 100,
'EmployeeID': 8
},
{
'ID': 36,
'Subject': 'Review Revenue Projections',
'StartDate': '2013/03/25',
'DueDate': '2013/04/06',
'Status': 'Completed',
'Priority': 'High',
'Completion': 100,
'EmployeeID': 9
},
{
'ID': 40,
'Subject': 'Provide New Health Insurance Docs',
'StartDate': '2013/03/28',
'DueDate': '2013/04/07',
'Status': 'Completed',
'Priority': 'Normal',
'Completion': 100,
'EmployeeID': 4
},
{
'ID': 41,
'Subject': 'Provide New Health Insurance Docs',
'StartDate': '2013/03/28',
'DueDate': '2013/04/07',
'Status': 'Completed',
'Priority': 'Normal',
'Completion': 100,
'EmployeeID': 6
},
{
'ID': 50,
'Subject': 'Give Final Approval for Refunds',
'StartDate': '2013/05/05',
'DueDate': '2013/05/15',
'Status': 'Completed',
'Priority': 'Normal',
'Completion': 100,
'EmployeeID': 2
},
{
'ID': 52,
'Subject': 'Review Product Recall Report by Engineering Team',
'StartDate': '2013/05/17',
'DueDate': '2013/05/20',
'Status': 'Completed',
'Priority': 'High',
'Completion': 100,
'EmployeeID': 1
},
{
'ID': 55,
'Subject': 'Review Overtime Report',
'StartDate': '2013/06/10',
'DueDate': '2013/06/14',
'Status': 'Completed',
'Priority': 'Normal',
'Completion': 100,
'EmployeeID': 7
},
{
'ID': 60,
'Subject': 'Refund Request Template',
'StartDate': '2013/06/17',
'DueDate': '2014/04/01',
'Status': 'Deferred',
'Priority': 'Normal',
'Completion': 0,
'EmployeeID': 9
},
{
'ID': 71,
'Subject': 'Upgrade Server Hardware',
'StartDate': '2013/07/22',
'DueDate': '2013/07/31',
'Status': 'Completed',
'Priority': 'Urgent',
'Completion': 100,
'EmployeeID': 7
},
{
'ID': 72,
'Subject': 'Upgrade Personal Computers',
'StartDate': '2013/07/24',
'DueDate': '2014/04/30',
'Status': 'In Progress',
'Priority': 'Normal',
'Completion': 85,
'EmployeeID': 7
},
{
'ID': 74,
'Subject': 'Decide on Mobile Devices to Use in the Field',
'StartDate': '2013/07/30',
'DueDate': '2013/08/02',
'Status': 'Completed',
'Priority': 'High',
'Completion': 100,
'EmployeeID': 3
},
{
'ID': 78,
'Subject': 'Try New Touch-Enabled WinForms Apps',
'StartDate': '2013/08/11',
'DueDate': '2013/08/15',
'Status': 'Completed',
'Priority': 'Normal',
'Completion': 100,
'EmployeeID': 3
},
{
'ID': 81,
'Subject': 'Review Site Up-Time Report',
'StartDate': '2013/08/24',
'DueDate': '2013/08/30',
'Status': 'Completed',
'Priority': 'Urgent',
'Completion': 100,
'EmployeeID': 5
},
{
'ID': 99,
'Subject': 'Submit D&B Number to ISP for Credit Approval',
'StartDate': '2013/11/04',
'DueDate': '2013/11/07',
'Status': 'Completed',
'Priority': 'High',
'Completion': 100,
'EmployeeID': 8
},
{
'ID': 117,
'Subject': 'Approval on Converting to New HDMI Specification',
'StartDate': '2014/01/11',
'DueDate': '2014/01/31',
'Status': 'Deferred',
'Priority': 'Normal',
'Completion': 75,
'EmployeeID': 3
},
{
'ID': 138,
'Subject': 'Review HR Budget Company Wide',
'StartDate': '2014/03/20',
'DueDate': '2014/03/25',
'Status': 'In Progress',
'Priority': 'Normal',
'Completion': 40,
'EmployeeID': 6
},
{
'ID': 145,
'Subject': 'Final Budget Review',
'StartDate': '2014/03/26',
'DueDate': '2014/03/27',
'Status': 'In Progress',
'Priority': 'High',
'Completion': 25,
'EmployeeID': 6
}];
export default {
getEmployees() {
return employees;
},
getTasks() {
return tasks;
}
};
System.config({
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader'
},
'devextreme/localization.js': {
"esModule": true
},
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'vue': 'npm:vue@3.0.0/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.5',
'devextreme-vue': 'npm:devextreme-vue@20.2.5',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.11/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.18/dist/dx-gantt.js',
'preact': 'npm:preact@10.5.11/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.11/hooks/dist/hooks.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js'
},
packages: {
'devextreme-vue': {
main: 'index.js'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true
}
});

import React from 'react';
import DataGrid,
{
Column,
MasterDetail,
} from 'devextreme-react/data-grid';
import DetailTemplate from './DetailTemplate.js';
import service from './data.js';
const employees = service.getEmployees();
class App extends React.Component {
render() {
return (
<DataGrid id="grid-container"
dataSource={employees}
keyExpr="ID"
showBorders={true}
>
<Column dataField="Prefix" width={70} caption="Title" />
<Column dataField="FirstName" />
<Column dataField="LastName" />
<Column dataField="Position" width={170} />
<Column dataField="State" width={125} />
<Column dataField="BirthDate" dataType="date" />
<MasterDetail
enabled={true}
component={DetailTemplate}
/>
</DataGrid>
);
}
}
export default App;
import React from 'react';
import { DataGrid, Column } from 'devextreme-react/data-grid';
import ArrayStore from 'devextreme/data/array_store';
import DataSource from 'devextreme/data/data_source';
import service from './data.js';
const tasks = service.getTasks();
class DetailTemplate extends React.Component {
constructor(props) {
super(props);
this.dataSource = getTasks(props.data.key);
}
render() {
const { FirstName, LastName } = this.props.data.data;
return (
<React.Fragment>
<div className="master-detail-caption">
{`${FirstName} ${LastName}'s Tasks:`}
</div>
<DataGrid
dataSource={this.dataSource}
showBorders={true}
columnAutoWidth={true}
>
<Column dataField="Subject" />
<Column dataField="StartDate" dataType="date" />
<Column dataField="DueDate" dataType="date" />
<Column dataField="Priority" />
<Column
caption="Completed"
dataType="boolean"
calculateCellValue={this.completedValue}
/>
</DataGrid>
</React.Fragment>
);
}
completedValue(rowData) {
return rowData.Status === 'Completed';
}
}
function getTasks(key) {
return new DataSource({
store: new ArrayStore({
data: tasks,
key: 'ID',
}),
filter: ['EmployeeID', '=', key],
});
}
export default DetailTemplate;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#grid-container {
height: 440px;
}
.master-detail-caption {
padding: 0 0 5px 10px;
font-size: 14px;
font-weight: bold;
}
const employees = [{
ID: 1,
Prefix: 'Mr.',
FirstName: 'John',
LastName: 'Heart',
Position: 'CEO',
State: 'California',
BirthDate: '1964/03/16',
},
{
ID: 2,
Prefix: 'Mrs.',
FirstName: 'Olivia',
LastName: 'Peyton',
Position: 'Sales Assistant',
State: 'California',
BirthDate: '1981/06/03',
},
{
ID: 3,
Prefix: 'Mr.',
FirstName: 'Robert',
LastName: 'Reagan',
Position: 'CMO',
State: 'Arkansas',
BirthDate: '1974/09/07',
},
{
ID: 4,
Prefix: 'Ms.',
FirstName: 'Greta',
LastName: 'Sims',
Position: 'HR Manager',
State: 'Georgia',
BirthDate: '1977/11/22',
},
{
ID: 5,
Prefix: 'Mr.',
FirstName: 'Brett',
LastName: 'Wade',
Position: 'IT Manager',
State: 'Idaho',
BirthDate: '1968/12/01',
},
{
ID: 6,
Prefix: 'Mrs.',
FirstName: 'Sandra',
LastName: 'Johnson',
Position: 'Controller',
State: 'Utah',
BirthDate: '1974/11/15',
},
{
ID: 7,
Prefix: 'Mr.',
FirstName: 'Kevin',
LastName: 'Carter',
Position: 'Shipping Manager',
State: 'California',
BirthDate: '1978/01/09',
},
{
ID: 8,
Prefix: 'Ms.',
FirstName: 'Cynthia',
LastName: 'Stanwick',
Position: 'HR Assistant',
State: 'Arkansas',
BirthDate: '1985/06/05',
},
{
ID: 9,
Prefix: 'Dr.',
FirstName: 'Kent',
LastName: 'Samuelson',
Position: 'Ombudsman',
State: 'Missouri',
BirthDate: '1972/09/11',
}];
const tasks = [{
ID: 1,
Subject: 'Prepare 2013 Financial',
StartDate: '2013/01/15',
DueDate: '2013/01/31',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 8,
},
{
ID: 2,
Subject: 'Prepare 3013 Marketing Plan',
StartDate: '2013/01/01',
DueDate: '2013/01/31',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 5,
},
{
ID: 3,
Subject: 'Update Personnel Files',
StartDate: '2013/02/03',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 2,
},
{
ID: 4,
Subject: 'Review Health Insurance Options Under the Affordable Care Act',
StartDate: '2013/02/12',
DueDate: '2013/04/25',
Status: 'In Progress',
Priority: 'High',
Completion: 50,
EmployeeID: 2,
},
{
ID: 5,
Subject: 'Choose between PPO and HMO Health Plan',
StartDate: '2013/02/15',
DueDate: '2013/04/15',
Status: 'In Progress',
Priority: 'High',
Completion: 75,
EmployeeID: 1,
},
{
ID: 6,
Subject: 'Google AdWords Strategy',
StartDate: '2013/02/16',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 7,
Subject: 'New Brochures',
StartDate: '2013/02/17',
DueDate: '2013/02/24',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 1,
},
{
ID: 11,
Subject: 'Rollout of New Website and Marketing Brochures',
StartDate: '2013/02/20',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 5,
},
{
ID: 12,
Subject: 'Update Sales Strategy Documents',
StartDate: '2013/02/20',
DueDate: '2013/02/22',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 9,
},
{
ID: 15,
Subject: 'Review 2012 Sales Report and Approve 2013 Plans',
StartDate: '2013/02/23',
DueDate: '2013/02/28',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 5,
},
{
ID: 16,
Subject: 'Deliver R&D Plans for 2013',
StartDate: '2013/03/01',
DueDate: '2013/03/10',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 3,
},
{
ID: 20,
Subject: 'Approve Hiring of John Jeffers',
StartDate: '2013/03/02',
DueDate: '2013/03/12',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 4,
},
{
ID: 20,
Subject: 'Approve Hiring of John Jeffers',
StartDate: '2013/03/02',
DueDate: '2013/03/12',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 6,
},
{
ID: 21,
Subject: 'Non-Compete Agreements',
StartDate: '2013/03/12',
DueDate: '2013/03/14',
Status: 'Completed',
Priority: 'Low',
Completion: 100,
EmployeeID: 2,
},
{
ID: 22,
Subject: 'Update NDA Agreement',
StartDate: '2013/03/14',
DueDate: '2013/03/16',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 23,
Subject: 'Update Employee Files with New NDA',
StartDate: '2013/03/16',
DueDate: '2013/03/26',
Status: 'Need Assistance',
Priority: 'Normal',
Completion: 90,
EmployeeID: 4,
},
{
ID: 24,
Subject: 'Update Employee Files with New NDA',
StartDate: '2013/03/16',
DueDate: '2013/03/26',
Status: 'Need Assistance',
Priority: 'Normal',
Completion: 90,
EmployeeID: 6,
},
{
ID: 25,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 7,
},
{
ID: 26,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 8,
},
{
ID: 27,
Subject: 'Sign Updated NDA',
StartDate: '2013/03/20',
DueDate: '2013/03/25',
Status: 'Need Assistance',
Priority: 'Urgent',
Completion: 25,
EmployeeID: 9,
},
{
ID: 35,
Subject: 'Update Revenue Projections',
StartDate: '2013/03/24',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 8,
},
{
ID: 36,
Subject: 'Review Revenue Projections',
StartDate: '2013/03/25',
DueDate: '2013/04/06',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 9,
},
{
ID: 40,
Subject: 'Provide New Health Insurance Docs',
StartDate: '2013/03/28',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 4,
},
{
ID: 41,
Subject: 'Provide New Health Insurance Docs',
StartDate: '2013/03/28',
DueDate: '2013/04/07',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 6,
},
{
ID: 50,
Subject: 'Give Final Approval for Refunds',
StartDate: '2013/05/05',
DueDate: '2013/05/15',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 2,
},
{
ID: 52,
Subject: 'Review Product Recall Report by Engineering Team',
StartDate: '2013/05/17',
DueDate: '2013/05/20',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 1,
},
{
ID: 55,
Subject: 'Review Overtime Report',
StartDate: '2013/06/10',
DueDate: '2013/06/14',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 7,
},
{
ID: 60,
Subject: 'Refund Request Template',
StartDate: '2013/06/17',
DueDate: '2014/04/01',
Status: 'Deferred',
Priority: 'Normal',
Completion: 0,
EmployeeID: 9,
},
{
ID: 71,
Subject: 'Upgrade Server Hardware',
StartDate: '2013/07/22',
DueDate: '2013/07/31',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 7,
},
{
ID: 72,
Subject: 'Upgrade Personal Computers',
StartDate: '2013/07/24',
DueDate: '2014/04/30',
Status: 'In Progress',
Priority: 'Normal',
Completion: 85,
EmployeeID: 7,
},
{
ID: 74,
Subject: 'Decide on Mobile Devices to Use in the Field',
StartDate: '2013/07/30',
DueDate: '2013/08/02',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 3,
},
{
ID: 78,
Subject: 'Try New Touch-Enabled WinForms Apps',
StartDate: '2013/08/11',
DueDate: '2013/08/15',
Status: 'Completed',
Priority: 'Normal',
Completion: 100,
EmployeeID: 3,
},
{
ID: 81,
Subject: 'Review Site Up-Time Report',
StartDate: '2013/08/24',
DueDate: '2013/08/30',
Status: 'Completed',
Priority: 'Urgent',
Completion: 100,
EmployeeID: 5,
},
{
ID: 99,
Subject: 'Submit D&B Number to ISP for Credit Approval',
StartDate: '2013/11/04',
DueDate: '2013/11/07',
Status: 'Completed',
Priority: 'High',
Completion: 100,
EmployeeID: 8,
},
{
ID: 117,
Subject: 'Approval on Converting to New HDMI Specification',
StartDate: '2014/01/11',
DueDate: '2014/01/31',
Status: 'Deferred',
Priority: 'Normal',
Completion: 75,
EmployeeID: 3,
},
{
ID: 138,
Subject: 'Review HR Budget Company Wide',
StartDate: '2014/03/20',
DueDate: '2014/03/25',
Status: 'In Progress',
Priority: 'Normal',
Completion: 40,
EmployeeID: 6,
},
{
ID: 145,
Subject: 'Final Budget Review',
StartDate: '2014/03/26',
DueDate: '2014/03/27',
Status: 'In Progress',
Priority: 'High',
Completion: 25,
EmployeeID: 6,
}];
export default {
getEmployees() {
return employees;
},
getTasks() {
return tasks;
},
};
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.3/cjs',
'devextreme-react': 'npm:devextreme-react@22.2.3',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.18/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.65/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.37/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.7.1/standalone.js',
'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

<dx-data-grid id="gridContainer" [dataSource]="employees" keyExpr="ID" [showBorders]="true">
<dxi-column dataField="Prefix" [width]="70" caption="Title"></dxi-column>
<dxi-column dataField="FirstName"></dxi-column>
<dxi-column dataField="LastName"></dxi-column>
<dxi-column dataField="Position" [width]="170"></dxi-column>
<dxi-column dataField="State" [width]="125"></dxi-column>
<dxi-column dataField="BirthDate" dataType="date"></dxi-column>
<dxo-master-detail [enabled]="true" template="detail"></dxo-master-detail>
<div *dxTemplate="let employee of 'detail'">
<div class="master-detail-caption">{{employee.data.FirstName + " " + employee.data.LastName + "'s Tasks:"}}</div>
<detail-grid [key]="employee.key"></detail-grid>
</div>
</dx-data-grid>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxDataGridModule, DxTemplateModule } from 'devextreme-angular';
import { Employee, Service } from './app.service';
import { DetailGridComponent } from './detail-grid/detail-grid.component';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service]
})
export class AppComponent {
employees: Employee[];
constructor(private service: Service) {
this.employees = service.getEmployees();
}
}
@NgModule({
imports: [
BrowserModule,
DxDataGridModule,
DxTemplateModule
],
declarations: [AppComponent, DetailGridComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #gridContainer {
height: 440px;
}
::ng-deep .master-detail-caption {
padding: 0 0 5px 10px;
font-size: 14px;
font-weight: bold;
}
import { Injectable } from '@angular/core';
export class Task {
ID: number;
Subject: string;
StartDate: string;
DueDate: string;
Status: string;
Priority: string;
Completion: number;
EmployeeID: number;
}
export class Employee {
ID: number;
FirstName: string;
LastName: string;
Prefix: string;
Position: string;
BirthDate: string;
State: string;
}
let employees: Employee[] = [{
"ID": 1,
"Prefix": "Mr.",
"FirstName": "John",
"LastName": "Heart",
"Position": "CEO",
"State": "California",
"BirthDate": "1964/03/16"
},
{
"ID": 2,
"Prefix": "Mrs.",
"FirstName": "Olivia",
"LastName": "Peyton",
"Position": "Sales Assistant",
"State": "California",
"BirthDate": "1981/06/03"
},
{
"ID": 3,
"Prefix": "Mr.",
"FirstName": "Robert",
"LastName": "Reagan",
"Position": "CMO",
"State": "Arkansas",
"BirthDate": "1974/09/07"
},
{
"ID": 4,
"Prefix": "Ms.",
"FirstName": "Greta",
"LastName": "Sims",
"Position": "HR Manager",
"State": "Georgia",
"BirthDate": "1977/11/22"
},
{
"ID": 5,
"Prefix": "Mr.",
"FirstName": "Brett",
"LastName": "Wade",
"Position": "IT Manager",
"State": "Idaho",
"BirthDate": "1968/12/01"
},
{
"ID": 6,
"Prefix": "Mrs.",
"FirstName": "Sandra",
"LastName": "Johnson",
"Position": "Controller",
"State": "Utah",
"BirthDate": "1974/11/15"
},
{
"ID": 7,
"Prefix": "Mr.",
"FirstName": "Kevin",
"LastName": "Carter",
"Position": "Shipping Manager",
"State": "California",
"BirthDate": "1978/01/09"
},
{
"ID": 8,
"Prefix": "Ms.",
"FirstName": "Cynthia",
"LastName": "Stanwick",
"Position": "HR Assistant",
"State": "Arkansas",
"BirthDate": "1985/06/05"
},
{
"ID": 9,
"Prefix": "Dr.",
"FirstName": "Kent",
"LastName": "Samuelson",
"Position": "Ombudsman",
"State": "Missouri",
"BirthDate": "1972/09/11"
}]
let tasks: Task[] = [{
"ID": 1,
"Subject": "Prepare 2013 Financial",
"StartDate": "2013/01/15",
"DueDate": "2013/01/31",
"Status": "Completed",
"Priority": "High",
"Completion": 100,
"EmployeeID": 8
},
{
"ID": 2, "Subject": "Prepare 3013 Marketing Plan",
"StartDate": "2013/01/01",
"DueDate": "2013/01/31",
"Status": "Completed",
"Priority": "High",
"Completion": 100,
"EmployeeID": 5
},
{
"ID": 3,
"Subject": "Update Personnel Files",
"StartDate": "2013/02/03",
"DueDate": "2013/02/28",
"Status": "Completed",
"Priority": "High",
"Completion": 100,
"EmployeeID": 2
},
{
"ID": 4,
"Subject": "Review Health Insurance Options Under the Affordable Care Act",
"StartDate": "2013/02/12",
"DueDate": "2013/04/25",
"Status": "In Progress",
"Priority": "High",
"Completion": 50,
"EmployeeID": 2
},
{
"ID": 5,
"Subject": "Choose between PPO and HMO Health Plan",
"StartDate": "2013/02/15",
"DueDate": "2013/04/15",
"Status": "In Progress", "Priority": "High",
"Completion": 75,
"EmployeeID": 1
},
{
"ID": 6,
"Subject": "Google AdWords Strategy",
"StartDate": "2013/02/16",
"DueDate": "2013/02/28",
"Status": "Completed",
"Priority": "High",
"Completion": 100,
"EmployeeID": 1
},
{
"ID": 7,
"Subject": "New Brochures",
"StartDate": "2013/02/17",
"DueDate": "2013/02/24",
"Status": "Completed",
"Priority": "Normal",
"Completion": 100,
"EmployeeID": 1
},
{
"ID": 11,
"Subject": "Rollout of New Website and Marketing Brochures",
"StartDate": "2013/02/20",
"DueDate": "2013/02/28",
"Status": "Completed",
"Priority": "High",
"Completion": 100,
"EmployeeID": 5
},
{
"ID": 12,
"Subject": "Update Sales Strategy Documents",
"StartDate": "2013/02/20",
"DueDate": "2013/02/22",
"Status": "Completed",
"Priority": "Normal",
"Completion": 100,
"EmployeeID": 9
},
{
"ID": 15,
"Subject": "Review 2012 Sales Report and Approve 2013 Plans",
"StartDate": "2013/02/23",
"DueDate": "2013/02/28",
"Status": "Completed",
"Priority": "Normal",
"Completion": 100,
"EmployeeID": 5
},
{
"ID": 16,
"Subject": "Deliver R&D Plans for 2013",
"StartDate": "2013/03/01",
"DueDate": "2013/03/10",
"Status": "Completed",
"Priority": "High",
"Completion": 100,
"EmployeeID": 3
},
{
"ID": 20,
"Subject": "Approve Hiring of John Jeffers",
"StartDate": "2013/03/02",
"DueDate": "2013/03/12",
"Status": "Completed",
"Priority": "Normal",
"Completion": 100,
"EmployeeID": 4
},
{
"ID": 20,
"Subject": "Approve Hiring of John Jeffers",
"StartDate": "2013/03/02",
"DueDate": "2013/03/12",
"Status": "Completed",
"Priority": "Normal",
"Completion": 100,
"EmployeeID": 6
},
{
"ID": 21,
"Subject": "Non-Compete Agreements",
"StartDate": "2013/03/12",
"DueDate": "2013/03/14",
"Status": "Completed",
"Priority": "Low",
"Completion": 100,
"EmployeeID": 2
},
{
"ID": 22,
"Subject": "Update NDA Agreement",
"StartDate": "2013/03/14",
"DueDate": "2013/03/16",
"Status": "Completed",
"Priority": "High",
"Completion": 100,
"EmployeeID": 1
},
{
"ID": 23,
"Subject": "Update Employee Files with New NDA",
"StartDate": "2013/03/16",
"DueDate": "2013/03/26",
"Status": "Need Assistance",
"Priority": "Normal",
"Completion": 90,
"EmployeeID": 4
},
{
"ID": 24,
"Subject": "Update Employee Files with New NDA",
"StartDate": "2013/03/16",
"DueDate": "2013/03/26",
"Status": "Need Assistance",
"Priority": "Normal",
"Completion": 90,
"EmployeeID": 6
},
{
"ID": 25,
"Subject": "Sign Updated NDA",
"StartDate": "2013/03/20",
"DueDate": "2013/03/25",
"Status": "Completed",
"Priority": "Urgent",
"Completion": 100,
"EmployeeID": 7
},
{
"ID": 26,
"Subject": "Sign Updated NDA",
"StartDate": "2013/03/20",
"DueDate": "2013/03/25",
"Status": "Completed",
"Priority": "Urgent",
"Completion": 100,
"EmployeeID": 8
},
{
"ID": 27,
"Subject": "Sign Updated NDA",
"StartDate": "2013/03/20",
"DueDate": "2013/03/25",
"Status": "Need Assistance",
"Priority": "Urgent",
"Completion": 25,
"EmployeeID": 9
},
{
"ID": 35,
"Subject": "Update Revenue Projections",
"StartDate": "2013/03/24",
"DueDate": "2013/04/07",
"Status": "Completed",
"Priority": "Normal",
"Completion": 100,
"EmployeeID": 8
},
{
"ID": 36,
"Subject": "Review Revenue Projections",
"StartDate": "2013/03/25",
"DueDate": "2013/04/06",
"Status": "Completed",
"Priority": "High",
"Completion": 100,
"EmployeeID": 9
},
{
"ID": 40,
"Subject": "Provide New Health Insurance Docs",
"StartDate": "2013/03/28",
"DueDate": "2013/04/07",
"Status": "Completed",
"Priority": "Normal",
"Completion": 100,
"EmployeeID": 4
},
{
"ID": 41,
"Subject": "Provide New Health Insurance Docs",
"StartDate": "2013/03/28",
"DueDate": "2013/04/07",
"Status": "Completed",
"Priority": "Normal",
"Completion": 100,
"EmployeeID": 6
},
{
"ID": 50,
"Subject": "Give Final Approval for Refunds",
"StartDate": "2013/05/05",
"DueDate": "2013/05/15",
"Status": "Completed",
"Priority": "Normal",
"Completion": 100,
"EmployeeID": 2
},
{
"ID": 52,
"Subject": "Review Product Recall Report by Engineering Team",
"StartDate": "2013/05/17",
"DueDate": "2013/05/20",
"Status": "Completed",
"Priority": "High",
"Completion": 100,
"EmployeeID": 1
},
{
"ID": 55,
"Subject": "Review Overtime Report",
"StartDate": "2013/06/10",
"DueDate": "2013/06/14",
"Status": "Completed",
"Priority": "Normal",
"Completion": 100,
"EmployeeID": 7
},
{
"ID": 60,
"Subject": "Refund Request Template",
"StartDate": "2013/06/17",
"DueDate": "2014/04/01",
"Status": "Deferred",
"Priority": "Normal",
"Completion": 0,
"EmployeeID": 9
},
{
"ID": 71,
"Subject": "Upgrade Server Hardware",
"StartDate": "2013/07/22",
"DueDate": "2013/07/31",
"Status": "Completed",
"Priority": "Urgent",
"Completion": 100,
"EmployeeID": 7
},
{
"ID": 72,
"Subject": "Upgrade Personal Computers",
"StartDate": "2013/07/24",
"DueDate": "2014/04/30",
"Status": "In Progress",
"Priority": "Normal",
"Completion": 85,
"EmployeeID": 7
},
{
"ID": 74,
"Subject": "Decide on Mobile Devices to Use in the Field",
"StartDate": "2013/07/30",
"DueDate": "2013/08/02",
"Status": "Completed",
"Priority": "High",
"Completion": 100,
"EmployeeID": 3
},
{
"ID": 78,
"Subject": "Try New Touch-Enabled WinForms Apps",
"StartDate": "2013/08/11",
"DueDate": "2013/08/15",
"Status": "Completed",
"Priority": "Normal",
"Completion": 100,
"EmployeeID": 3
},
{
"ID": 81,
"Subject": "Review Site Up-Time Report",
"StartDate": "2013/08/24",
"DueDate": "2013/08/30",
"Status": "Completed",
"Priority": "Urgent",
"Completion": 100,
"EmployeeID": 5
},
{
"ID": 99,
"Subject": "Submit D&B Number to ISP for Credit Approval",
"StartDate": "2013/11/04",
"DueDate": "2013/11/07",
"Status": "Completed",
"Priority": "High",
"Completion": 100,
"EmployeeID": 8
},
{
"ID": 117,
"Subject": "Approval on Converting to New HDMI Specification",
"StartDate": "2014/01/11",
"DueDate": "2014/01/31",
"Status": "Deferred",
"Priority": "Normal",
"Completion": 75,
"EmployeeID": 3
},
{
"ID": 138,
"Subject": "Review HR Budget Company Wide",
"StartDate": "2014/03/20",
"DueDate": "2014/03/25",
"Status": "In Progress",
"Priority": "Normal",
"Completion": 40,
"EmployeeID": 6
},
{
"ID": 145,
"Subject": "Final Budget Review",
"StartDate": "2014/03/26",
"DueDate": "2014/03/27",
"Status": "In Progress",
"Priority": "High",
"Completion": 25,
"EmployeeID": 6
}]
@Injectable()
export class Service {
getEmployees() {
return employees;
}
getTasks(){
return tasks;
}
}
// In real applications, you should not transpile code in the browser. You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
System.config({
transpiler: 'ts',
typescriptOptions: {
module: "system",
emitDecoratorMetadata: true,
experimentalDecorators: true
},
meta: {
'typescript': {
"exports": "ts"
},
'devextreme/localization.js': {
"esModule": true
}
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@3.5.3/lib/typescript.js',
'@angular': 'npm:@angular',
'tslib': 'npm:tslib@2.1.0/tslib.js',
'rxjs': 'npm:rxjs@6.4.0',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.26.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.6',
'jszip': 'npm:jszip@3.6.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.10.3/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.18',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.24',
'devextreme-angular': 'npm:devextreme-angular@20.2.6',
'preact': 'npm:preact@10.5.13/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.13/hooks/dist/hooks.js'
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
packageConfigPaths: [
"npm:@angular/*/package.json",
"npm:@angular/common/*/package.json",
"npm:rxjs/package.json",
"npm:rxjs/operators/package.json",
"npm:devextreme-angular/*/package.json",
"npm:devextreme-angular/ui/*/package.json",
"npm:devextreme-angular/package.json",
"npm:devexpress-diagram/package.json",
"npm:devexpress-gantt/package.json",
]
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.10.2/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import('app').catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
<dx-data-grid [dataSource]="tasksDataSource" [showBorders]="true" [columnAutoWidth]="true">
<dxi-column dataField="Subject" dataType="string"></dxi-column>
<dxi-column dataField="StartDate" dataType="date"></dxi-column>
<dxi-column dataField="DueDate" dataType="date"></dxi-column>
<dxi-column dataField="Priority" dataType="string"></dxi-column>
<dxi-column caption="Completed" dataType="boolean" [calculateCellValue]="completedValue"></dxi-column>
</dx-data-grid>
import { Component, Input, AfterViewInit } from '@angular/core';
import DataSource from 'devextreme/data/data_source';
import ArrayStore from 'devextreme/data/array_store';
import { Service, Task } from '../app.service';
@Component({
selector: 'detail-grid',
templateUrl: 'app/detail-grid/detail-grid.component.html',
styleUrls: ['app/detail-grid/detail-grid.component.css'],
providers: [Service]
})
export class DetailGridComponent implements AfterViewInit {
@Input() key: number;
tasksDataSource: DataSource;
tasks: Task[];
constructor(private service: Service) {
this.tasks = service.getTasks();
}
ngAfterViewInit() {
this.tasksDataSource = new DataSource({
store: new ArrayStore({
data: this.tasks,
key: "ID"
}),
filter: ["EmployeeID", "=", this.key]
})
}
completedValue(rowData) {
return rowData.Status == "Completed";
}
}